;============================== ROUTINES GENERALES =================================

;----- test d'galit -----
; entres: HL, DE
; sorties: HL=1 si gal, sinon HL=0
test_egalite:
	call _cphlde
	ld hl,0
	jr nz,test_egalite_faux
test_egalite_vrai:
	inc hl
test_egalite_faux:
	ret

;----- test different -----
; entres: HL, DE
; sorties: HL=1 si diffrent, sinon HL=0
test_diff:
	call _cphlde
	ld hl,0
	jr z,test_diff_vrai
test_diff_faux:
	inc hl
test_diff_vrai:
	ret

;----- test suprieur ou gal -----
; entres: HL, DE
; sorties: HL=1 si HL>=DE, sinon HL=0
test_supegal:
	inc de
	jr test_strsup
;----- test infrieur ou gal -----
; entres: HL, DE
; sorties: HL=1 si HL<=DE, sinon HL=0
test_infegal:
	dec de
;----- test strictement inferieur -----
; entres: HL, DE
; sorties: HL=1 si HL<DE, sinon HL=0
test_strinf:
	ex de,hl
;----- test strictement suprieur -----
; entres: HL, DE
; sorties: HL=1 si HL>DE, sinon HL=0
test_strsup:
	SCF \ CCF \ sbc hl, de
	ld a,10000000b \ and h \ cp 0
	ld hl,0
	jr z,test_strsup_vrai
test_strsup_faux:
	inc hl
test_strsup_vrai:
	ret

;----- test AND -----
; entres: HL, DE
; sorties: HL = HL and DE
test_et:
	ld a,d \ and h \ ld h,a
	ld a,e \ and l \ ld l,a
	ret

;----- test OU -----
; entres: HL, DE
; sorties: HL = HL or DE
test_ou:
	ld a,d \ or h \ ld h,a
	ld a,e \ or l \ ld l,a
	ret

;-----------------------------------------------------------------------------------
